# Method: providers.vehicles.update

- [HTTP request](https://developers.google.com/maps/documentation/mobility/fleet-engine/reference/trips/rest/v1/providers.vehicles/update#body.HTTP_TEMPLATE)
- [Path parameters](https://developers.google.com/maps/documentation/mobility/fleet-engine/reference/trips/rest/v1/providers.vehicles/update#body.PATH_PARAMETERS)
- [Query parameters](https://developers.google.com/maps/documentation/mobility/fleet-engine/reference/trips/rest/v1/providers.vehicles/update#body.QUERY_PARAMETERS)
- [Request body](https://developers.google.com/maps/documentation/mobility/fleet-engine/reference/trips/rest/v1/providers.vehicles/update#body.request_body)
- [Response body](https://developers.google.com/maps/documentation/mobility/fleet-engine/reference/trips/rest/v1/providers.vehicles/update#body.response_body)

Writes updated vehicle data to the Fleet Engine.

When updating a `Vehicle`, the following fields cannot be updated since they are managed by the server:

- `currentTrips`
- `availableCapacity`
- `currentRouteSegmentVersion`
- `waypointsVersion`

The vehicle `name` also cannot be updated.

If the `attributes` field is updated, **all** the vehicle's attributes are replaced with the attributes provided in the request. If you want to update only some attributes, see the `vehicles.updateAttributes` method. Likewise, the `waypoints` field can be updated, but must contain all the waypoints currently on the vehicle, and no other waypoints.

### HTTP request

`PUT https://fleetengine.googleapis.com/v1/{name=providers/*/vehicles/*}`

The URL uses [gRPC Transcoding](https://google.aip.dev/127) syntax.

### Path parameters

| Parameters ||
|---|---|
| `name` | `string` Required. Must be in the format `providers/{provider}/vehicles/{vehicle}`. The {provider} must be the Project ID (for example, `sample-cloud-project`) of the Google Cloud Project of which the service account making this call is a member. |

### Query parameters

| Parameters ||
|---|---|
| `header` | ``object (`https://developers.google.com/maps/documentation/mobility/fleet-engine/reference/trips/rest/v1/RequestHeader`)`` The standard Fleet Engine request header. |
| `updateMask` | ``string (`https://protobuf.dev/reference/protobuf/google.protobuf#field-mask` format)`` Required. A field mask indicating which fields of the `Vehicle` to update. At least one field name must be provided. This is a comma-separated list of fully qualified names of fields. Example: `"user.displayName,photo"`. |

### Request body

The request body contains an instance of `https://developers.google.com/maps/documentation/mobility/fleet-engine/reference/trips/rest/v1/providers.vehicles#Vehicle`.

### Response body

If successful, the response body contains an instance of `https://developers.google.com/maps/documentation/mobility/fleet-engine/reference/trips/rest/v1/providers.vehicles#Vehicle`.